# oktob.js 

<div dir="rtl">
**أُكْتُبْ** مكتبة جافاسكربت مستوحاة من مشروع <a href="https://github.com/ASammour/DidYouMeanJS">DidYouMeanJS</a> ومن موقع التسجيل للحج التابع لوزارة الداخلية الجزائرية. 

مهمّة المكتبة الأساسية هي استبدال الأحرف اللاتنية بما يقابلها من الأحرف العربية حسب تخطيط لوحة المفاتيح (والعكس، أي التحويل من الأحرف العربية إلى الإنجليزية). مثلا عند كتابة الحرف `a` وحسب تخطيط `AZERTY` يتم استبداله بـ `ض` .

المكتبة تحتوى على API يجعلها مرنة وذات تخصيص واستعمال واسع، إن كنت ترى أنها تحتاج إلى مزيد من التحسين أو إلى دعم تخطيطات للوحات مفاتيح أخرى، ﻻ تتردد في المساهمة أو فتح Issue.

## المميزات

* تحويل مدخلات لوحة المفاتيح من اللاتنية (إنجليزية، فرنسية..) إلى العربية حسب خيار تخطيط لوحة المفاتيح
* تحويل المدخلات من العربية إلى اللاتنية حسب خيار تخطيط لوحة المفاتيح
* تحويل الأرقام (مثلا من ۵ إلى 5)
* التوفّر على API للمرونة ولاستخدام أوسع
* خاصيّة تجاهل أو تمكين التشكيل

### تخطيطات لوحات المفاتيح المدعومة

* AZERTY
* QWERTY

إن كنت ترى أن هناك تخطيطا يجب أن يُدعم، ﻻ تتردد بالمساهمة أو بفتح Issue حتى يتم دعمه في أقصر الآجال.

## التثبيت

### npm

`npm i -S oktob.js`

### عبر وسم script

```html
<script src="dist/oktob.min.js"></script>
```

## مهام يجب معالجتها

- في حالة استعمال جهاز أندرويد أو أيفون، هل يبقى نفس التخطيط؟ أم علينا معالجته كحالة خاصة (إضافة `azerty-mobile` كخيار منفصل).
- كتابة دالّة للتحقق الآلي من نوع تخطيط لوحة المفاتيح، أو استعمال مكتبات جاهزة.
- كتابة Unit test.


</div>

## الواجهة البرمجية (API)

* QWERTY
    * `replaceEnCharsQWERTY(text)` تحويل النص من الإنجليزية إلى العربية حسب تخطيط كويرتي
    * `replaceArCharsQWERTY(text)` تحويل النص من العربية إلى الإنجليزية حسب تخطيط كويرتي
* AZERTY
    * `replaceEnCharsAZERTY(text)` تحويل النص من الإنجليزية إلى العربية حسب تخطيط آزرتي
    * `replaceArCharsAZERTY(text)` تحويل النص من العربية إلى الإنجليزية حسب تخطيط آزرتي

* API
    * `getKbLayout()` تُرتجع اسم تخطيط لوحة المفاتيح حسب الإعدادات الحالية
    * `setKbLayout(kbLayoutName)` تعديل الإعدادات بتمرير تخطيط لوحة مفاتيح جديد (من بين التخطيطات التي تدعمها المكتبة)

## License

<p dir="rtl">
هذا المشروع تحت رخصة رخصة جنو العمومية (الإصدار الثالث).
</p>

This project is licensed under the GNU GPL v3.0 License - see the [LICENSE](./LICENSE) file for details
